pipeline {
  agent any

    environment {
        
        reg_address = "421320058418.dkr.ecr.us-west-2.amazonaws.com"
        repo = "robot-shop-ashutosh"
        gitlab = credentials('gitlab-id')
        
    }

    stages {
        stage('Checkout') {
          
            steps {
                git 'https://github.com/Ashutosh-aws/robot-shop.git'
            } 
                
        }
        
        stage('build docker'){
            steps{
          
                sh  'docker build -t cart/robot-shop cart/'
                sh 'docker tag cart/robot-shop ${reg_address}/${repo}:cart-build-${BUILD_NUMBER}'
                 }
        }
        stage('ECR logging'){
                steps{

                 sh 'aws ecr get-login-password --region us-west-2 | docker login --username AWS --password-stdin 421320058418.dkr.ecr.us-west-2.amazonaws.com'
                }
        }
        
        stage('docker push'){
                 steps{
                     sh 'docker push ${reg_address}/${repo}:cart-build-${BUILD_NUMBER}'
                 }
        }

        stage('helm update'){
            steps{
              sh """
                rm -rf robot-shop
                git clone https://gitlab.com/ashutosh.behera888/robot-shop.git
                cd robot-shop
                sed -i 's/cart.*/cart: cart-build-${BUILD_NUMBER}/' K8s/helm/values.yaml
                git add .
                git commit -m "updated images values in helm repo for cart microservice"
                git push https://$gitlab_USR:$gitlab_PSW@gitlab.com/ashutosh.behera888/robot-shop.git
                cd .. && rm -rf robot-shop

                """

            }
        } 
    }
  
}
